package org.casalib.util
{
   public class ArrayUtil
   {
      public function ArrayUtil()
      {
         super();
      }
      
      protected static function _sortRandom(a:*, b:*) : int
      {
         return !!NumberUtil.randomIntegerWithinRange(0,1) ? 1 : -1;
      }
      
      public static function containsAll(inArray:Array, items:Array) : Boolean
      {
         var l:uint = items.length;
         while(l--)
         {
            if(inArray.indexOf(items[l]) == -1)
            {
               return false;
            }
         }
         return true;
      }
      
      protected static function _removeDuplicatesFilter(e:*, i:int, inArray:Array) : Boolean
      {
         return i == 0 ? true : inArray.lastIndexOf(e,i - 1) == -1;
      }
      
      public static function equals(first:Array, second:Array) : Boolean
      {
         var i:uint = first.length;
         if(i != second.length)
         {
            return false;
         }
         while(i--)
         {
            if(first[i] != second[i])
            {
               return false;
            }
         }
         return true;
      }
      
      public static function getHighestValue(inArray:Array) : Number
      {
         return inArray[inArray.sort(0x10 | 8)[inArray.length - 1]];
      }
      
      public static function sum(inArray:Array) : Number
      {
         var t:Number = 0;
         var l:uint = inArray.length;
         while(l--)
         {
            t += inArray[l];
         }
         return t;
      }
      
      public static function removeDuplicates(inArray:Array) : Array
      {
         return inArray.filter(ArrayUtil._removeDuplicatesFilter);
      }
      
      public static function containsAny(inArray:Array, items:Array) : Boolean
      {
         var l:uint = items.length;
         while(l--)
         {
            if(inArray.indexOf(items[l]) != -1)
            {
               return true;
            }
         }
         return false;
      }
      
      public static function getIndexOfDifference(first:Array, second:Array, fromIndex:uint = 0) : int
      {
         var i:int = int(fromIndex - 1);
         while(++i < first.length)
         {
            if(first[i] != second[i])
            {
               return i;
            }
         }
         return -1;
      }
      
      public static function randomize(inArray:Array) : Array
      {
         var t:Array = new Array();
         var r:Array = inArray.sort(ArrayUtil._sortRandom,Array.RETURNINDEXEDARRAY);
         var i:int = -1;
         while(++i < inArray.length)
         {
            t.push(inArray[r[i]]);
         }
         return t;
      }
      
      public static function addItemsAt(tarArray:Array, items:Array, index:int = 2147483647) : Boolean
      {
         if(items.length == 0)
         {
            return false;
         }
         var args:Array = items.concat();
         args.splice(0,0,index,0);
         tarArray.splice.apply(null,args);
         return true;
      }
      
      public static function removeItem(tarArray:Array, item:*) : uint
      {
         var i:int = int(tarArray.indexOf(item));
         var f:uint = 0;
         while(i != -1)
         {
            tarArray.splice(i,1);
            i = int(tarArray.indexOf(item,i));
            f++;
         }
         return f;
      }
      
      public static function getLowestValue(inArray:Array) : Number
      {
         return inArray[inArray.sort(0x10 | 8)[0]];
      }
      
      public static function retainItems(tarArray:Array, items:Array) : Boolean
      {
         var removed:Boolean = false;
         var l:uint = tarArray.length;
         while(l--)
         {
            if(items.indexOf(tarArray[l]) == -1)
            {
               tarArray.splice(l,1);
               removed = true;
            }
         }
         return removed;
      }
      
      public static function removeItems(tarArray:Array, items:Array) : Boolean
      {
         var removed:Boolean = false;
         var l:uint = tarArray.length;
         while(l--)
         {
            if(items.indexOf(tarArray[l]) != -1)
            {
               tarArray.splice(l,1);
               removed = true;
            }
         }
         return removed;
      }
      
      public static function average(inArray:Array) : Number
      {
         if(inArray.length == 0)
         {
            return 0;
         }
         return ArrayUtil.sum(inArray) / inArray.length;
      }
      
      public static function contains(inArray:Array, item:*) : uint
      {
         var i:int = int(inArray.indexOf(item,0));
         var t:uint = 0;
         while(i != -1)
         {
            i = int(inArray.indexOf(item,i + 1));
            t++;
         }
         return t;
      }
   }
}

