package org.casalib.util
{
   import flash.geom.ColorTransform;
   import org.casalib.math.Percent;
   
   public class ColorUtil
   {
      public function ColorUtil()
      {
         super();
      }
      
      public static function getARGB(color:uint) : Object
      {
         var c:Object = {};
         c.a = color >> 24 & 0xFF;
         c.r = color >> 16 & 0xFF;
         c.g = color >> 8 & 0xFF;
         c.b = color & 0xFF;
         return c;
      }
      
      public static function interpolateColor(begin:ColorTransform, end:ColorTransform, amount:Percent) : ColorTransform
      {
         var interpolation:ColorTransform = new ColorTransform();
         interpolation.redMultiplier = NumberUtil.interpolate(amount,begin.redMultiplier,end.redMultiplier);
         interpolation.greenMultiplier = NumberUtil.interpolate(amount,begin.greenMultiplier,end.greenMultiplier);
         interpolation.blueMultiplier = NumberUtil.interpolate(amount,begin.blueMultiplier,end.blueMultiplier);
         interpolation.alphaMultiplier = NumberUtil.interpolate(amount,begin.alphaMultiplier,end.alphaMultiplier);
         interpolation.redOffset = NumberUtil.interpolate(amount,begin.redOffset,end.redOffset);
         interpolation.greenOffset = NumberUtil.interpolate(amount,begin.greenOffset,end.greenOffset);
         interpolation.blueOffset = NumberUtil.interpolate(amount,begin.blueOffset,end.blueOffset);
         interpolation.alphaOffset = NumberUtil.interpolate(amount,begin.alphaOffset,end.alphaOffset);
         return interpolation;
      }
      
      public static function getHexStringFromRGB(r:uint, g:uint, b:uint) : String
      {
         var rr:String = r.toString(16);
         var gg:String = g.toString(16);
         var bb:String = b.toString(16);
         rr = rr.length == 1 ? "0" + rr : rr;
         gg = gg.length == 1 ? "0" + gg : gg;
         bb = bb.length == 1 ? "0" + bb : bb;
         return (rr + gg + bb).toUpperCase();
      }
      
      public static function getRGB(color:uint) : Object
      {
         var c:Object = {};
         c.r = color >> 16 & 0xFF;
         c.g = color >> 8 & 0xFF;
         c.b = color & 0xFF;
         return c;
      }
      
      public static function getHexStringFromARGB(a:uint, r:uint, g:uint, b:uint) : String
      {
         var aa:String = a.toString(16);
         var rr:String = r.toString(16);
         var gg:String = g.toString(16);
         var bb:String = b.toString(16);
         aa = aa.length == 1 ? "0" + aa : aa;
         rr = rr.length == 1 ? "0" + rr : rr;
         gg = gg.length == 1 ? "0" + gg : gg;
         bb = bb.length == 1 ? "0" + bb : bb;
         return (aa + rr + gg + bb).toUpperCase();
      }
      
      public static function getColor(r:uint, g:uint, b:uint, a:uint = 255) : uint
      {
         return a << 24 | r << 16 | g << 8 | b;
      }
   }
}

