package org.casalib.util
{
   import flash.external.ExternalInterface;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import org.casalib.errors.ArguementTypeError;
   
   public class NavigateUtil
   {
      public static const WINDOW_SELF:String = "_self";
      
      public static const WINDOW_BLANK:String = "_blank";
      
      public static const WINDOW_PARENT:String = "_parent";
      
      public static const WINDOW_TOP:String = "_top";
      
      public function NavigateUtil()
      {
         super();
      }
      
      public static function openUrl(request:*, window:String = "_self") : void
      {
         if(request is String)
         {
            request = new URLRequest(request);
         }
         else if(!(request is URLRequest))
         {
            throw new ArguementTypeError("request");
         }
         if(window == NavigateUtil.WINDOW_BLANK && ExternalInterface.available && !LocationUtil.isIde() && request.data == null)
         {
            if(NavigateUtil.openWindow(request.url,window))
            {
               return;
            }
         }
         navigateToURL(request,window);
      }
      
      public static function openWindow(url:String, window:String = "_blank", features:String = "") : Boolean
      {
         return ExternalInterface.call("function casaOpenWindow(url, windowOrName, features) { return window.open(url, windowOrName, features) != null; }",url,window == NavigateUtil.WINDOW_BLANK ? "casaWindow" + int(1000 * Math.random()) : window,features);
      }
   }
}

